<!-- 
Copyright (C) 2023. Stichting Moving Bird 
Joy Brand, joy.brand@projectmarch.nl 
Thijn Hoekstra, thijn.hoekstra@projectmarch.nl 

This program is free software: you can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation, either version 3 of the License, or 
(at your option) any later version. 

This program is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
GNU General Public License for more details. 

See <https://www.gnu.org/licenses/>. 

This XML was compiled by xml_generator.py at 06/04/2023 12:32:05 
using march8_v0_pre.xml and march8_v0.yaml. -->

<mujoco model="exoskeleton">
  <compiler meshdir="meshes" angle="degree" autolimits="true"/>
  <size nuser_actuator='1' nuser_sensor='1' nuser_geom='1'/>
  <option timestep='0.0005' iterations='50' solver='PGS' gravity='0 0 -9.81'/>
  <!-- Degree of Freedom: 27
       Actuators: 21
  -->
  <!-- Timestep is set to X because the high level control runs at X kHz -->

  <asset>
    <texture type="skybox" builtin="gradient" rgb1=".3 .5 .7" rgb2="0 0 0" width="512" height="512"/>
    <texture name="body" type="cube" builtin="flat" mark="cross" width="127" height="1278"
             rgb1="0.8 0.6 0.4" rgb2="0.8 0.6 0.4" markrgb="1 1 1" random="0.01"/>
    <texture name="grid" type="2d" builtin="checker" width="512" height="512" rgb1=".1 .2 .3" rgb2=".2 .3 .4"/>
    <material name="grid" texture="grid" texrepeat="1 1" texuniform="true" reflectance=".2"/>
    <material name="mujoco_orange" texture="body" texuniform="true" rgba="0.8 0.6 .4 1"/>
    <material name="march_grey" rgba=".87 .89 .91 1"/>
    <mesh name="backpack"    file="m8/Backpack.obj"/>
    <mesh name="L_foot"      file="m8/FootLeft.obj"/>
    <mesh name="L_hip"       file="m8/HipLeft.obj"/>
    <mesh name="L_thigh"     file="m8/UpperLegLeft.obj"/>
    <mesh name="L_shin"      file="m8/LowerLegLeft.obj"/>
    <mesh name="R_foot"     scale="1 -1 1"    file="m8/FootLeft.obj"/>
    <mesh name="R_hip"      scale="1 -1 1"    file="m8/HipLeft.obj"/>
    <mesh name="R_thigh"    scale="1 -1 1"    file="m8/UpperLegLeft.obj"/>
    <mesh name="R_shin"     scale="1 -1 1"    file="m8/LowerLegLeft.obj"/>
  </asset>

  <default>
    <site group="5"/>
    <motor ctrlrange="-1 1" ctrllimited="true"/>
    <geom contype="0" conaffinity="0" condim="1" solref="0.005 1"/>
    <equality solref="0.005 1"/>
    <default class="exoskeleton">
      <geom material="march_grey" group="2"/>
    </default>
    <default class="collision">
      <geom contype="1" group="3" type="capsule"/>
      <default class="L_collision">
        <geom contype="2" conaffinity="4"/>
      </default>
      <default class="R_collision">
        <geom contype="4" conaffinity="2"/>
      </default>
    </default>
    <default class="ballast">
      <geom contype="0" material="mujoco_orange" conaffinity="0" group="2" type="capsule" density="985"/>
    </default>
    <default class="HAA_joint">
      <joint damping="107.692308"
             frictionloss="0" stiffness="0"/>
    </default>
    <default class="ADPF_joint">
      <joint damping="43.658537"
             frictionloss="0" stiffness="0"/>
    </default>
    <default class="rotational_joint">
      <joint damping="63.451777"
             frictionloss="0" stiffness="0"/>
    </default>
  </default>

  <visual>
    <map force="0.1" zfar="30"/>
    <rgba haze="0.15 0.25 0.35 1"/>
    <quality shadowsize="4096"/>
    <global offwidth="800" offheight="800"/>
  </visual>

  <worldbody>
    <geom name="floor" size="0 0 .05" type="plane" material="grid" conaffinity="15" condim="3"/>
    <light name="spotlight" mode="targetbodycom" target="backpack"
           diffuse=".8 .8 .8" specular="0.3 0.3 0.3" pos="0 -20 4" cutoff="10"/>

    <body name="backpack"
          pos="0 0 0.95"
          childclass="exoskeleton">
      <light name="top" pos="0 0 2" mode="trackcom"/>
      <camera name="diag" pos="3 -2.5 1" xyaxes="1 1 0 0 1 2" mode="trackcom"/>
      <camera name="right" pos="0 -3 1" xyaxes="1 0 0 0 1 2" mode="trackcom"/>
      <site name='imu_backpack' size='0.01' pos="0 0 0"/>
      <inertial pos="0.013 0.001 0.24" mass="11.02"
                fullinertia="0.379 0.245 0.173 0 -0.008 0.001"/>
      <freejoint/>
      <geom type="mesh" mesh="backpack" />
      <geom name="backpack" type="box"
            size="0.051 0.189 0.165"
            pos="-0.02 0 0.13" class="collision"/>
      <geom name="pilot_torso" fromto=".147 0 .056 .190 0 .500" size=".161" class="ballast"/>
        <site name="imu_torso" size='0.01' pos="0.2 0 0.4"/>

      <!--  LEFT LEG -->
      <body name="L_hip" pos="-0.021 0.08 0.025">
        <inertial pos="0.065 0.112 0" mass="1.277"
                  fullinertia="0.006 0.006 0.011 -0.004 0 0"/>
        <joint name="L_HAA" axis="-1 0 0" range="-15 10" class="HAA_joint"/>
        <geom type="mesh" mesh="L_hip" />
        <geom name="L_hip" fromto="0 0 0 0.182 0.182 0"
              size="0.032" class="L_collision"/>
        <site name="tor_L_HAA" size="0.01" pos="0 0 0"/>

        <body name="L_UL" pos="0.182 0.182 0">
        <inertial pos="0 -0.034 -0.206" mass="8.566"
                  fullinertia="0.259 0.256 0.023 -0.001 0 -0.036"/>
          <joint name="L_HFE" axis="0 -1 0" range="-12 115" class="rotational_joint"/>
          <geom type="mesh" mesh="L_thigh" pos="0 .013 0" />
          <geom name="L_UL" fromto="0 0 0 0 -0.06 -0.413"
              size="0.069" class="L_collision"/>
          <geom name="L_pilot_thigh" fromto="0 -.166 -.05 0 -.149 -.423" size=".069" class="ballast"/>
          <site name="tor_L_HFE" size="0.01" pos="0 0 0"/>

          <body name="L_LL" pos="0 -0.06 -0.413">
            <inertial pos="-0.034 -0.04 -0.223" mass="4.159"
                  fullinertia="0.055 0.064 0.019 0.001 -0.006 -0.002"/>
            <joint name="L_KFE" axis="0 1 0" range="-1 112" class="rotational_joint"/>
            <geom type="mesh" mesh="L_shin"/>
            <geom name="L_LL" fromto="0 0 0 0.0 -0.037 -0.414"
              size="0.047" class="L_collision"/>
            <geom name="L_pilot_shin" fromto="0 -.116 0 0 -.124 -.399"  size=".047" class="ballast"/>
            <site name="tor_L_KFE" size="0.01" pos="0 0 0"/>

            <body name="L_foot" pos="0.0 -0.037 -0.414">
              <inertial pos="0.033 -0.041 -0.08" mass="1.22"
                  fullinertia="0.006 0.01 0.008 0.001 0.002 -0.002"/>
              <joint name="L_ADPF" axis="0 -1 0" range="-25 1" class="ADPF_joint"/>
              <geom type="mesh" mesh="L_foot"/>
              <site name="tor_L_ADPF" size="0.01" pos="0 0 0"/>

              <!-- The L_foot geometry models a footplate which extends past the pressure pads on the soles-->
              <geom name="L_foot" type="box" size="0.159 0.057 0.007"
                  pos="0.069 -0.086 -0.118"  class="L_collision"
                  friction="0.33"/>

              <!-- Pressure sole  -->
             <body name="pres_L_0" pos="-0.045 -0.072 -0.138">
                <geom name="pres_L_0" type="sphere" pos="0 0 0"
                      size="0.01" class="L_collision"  friction="0.33"/>
                <site name="pres_L_0"/>
              </body>
              <body name="pres_L_1" pos="-0.045 -0.072 -0.138">
                <geom name="pres_L_1" type="sphere" pos="0 0 0"
                      size="0.01" class="L_collision"  friction="0.33"/>
                <site name="pres_L_1"/>
              </body>
              <body name="pres_L_2" pos="0.05 -0.061 -0.138">
                <geom name="pres_L_2" type="sphere" pos="0 0 0"
                      size="0.01" class="L_collision"  friction="0.33"/>
                <site name="pres_L_2"/>
              </body>
              <body name="pres_L_3" pos="0.118 -0.05 -0.138">
                <geom name="pres_L_3" type="sphere" pos="0 0 0"
                      size="0.01" class="L_collision"  friction="0.33"/>
                <site name="pres_L_3"/>
              </body>
              <body name="pres_L_4" pos="0.13 -0.083 -0.138">
                <geom name="pres_L_4" type="sphere" pos="0 0 0"
                      size="0.01" class="L_collision"  friction="0.33"/>
                <site name="pres_L_4"/>
              </body>
              <body name="pres_L_5" pos="0.137 -0.115 -0.138">
                <geom name="pres_L_5" type="sphere" pos="0 0 0"
                      size="0.01" class="L_collision"  friction="0.33"/>
                <site name="pres_L_5"/>
              </body>
              <body name="pres_L_6" pos="0.174 -0.07 -0.138">
                <geom name="pres_L_6" type="sphere" pos="0 0 0"
                      size="0.01" class="L_collision"  friction="0.33"/>
                <site name="pres_L_6"/>
              </body>
              <body name="pres_L_7" pos="0.184 -0.105 -0.138">
                <geom name="pres_L_7" type="sphere" pos="0 0 0"
                      size="0.01" class="L_collision"  friction="0.33"/>
                <site name="pres_L_7"/>
              </body>
            </body>
          </body>
        </body>
      </body>

      <!--  RIGHT LEG -->
      <body name="R_hip" pos="-0.021 -0.08 0.025">
        <inertial pos="0.065 -0.112 0" mass="1.277"
                  fullinertia="0.006 0.006 0.011 0.004 0 -0"/>
        <joint name="R_HAA" axis="1 0 0" range="-15 10" class="HAA_joint"/>
        <geom type="mesh" mesh="R_hip" />
        <geom name="R_hip" fromto="0 0 0 0.182 -0.182 0"
              size="0.032" class="R_collision"/>
        <site name="tor_R_HAA" size="0.01" pos="0 0 0"/>

        <body name="R_UL" pos="0.182 -0.182 0">
          <inertial pos="0 0.034 -0.206" mass="8.566"
                  fullinertia="0.259 0.256 0.023 0.001 0 0.036"/>
          <joint name="R_HFE" axis="0 -1 0" range="-12 115" class="rotational_joint"/>
          <geom type="mesh" mesh="R_thigh"/>
          <geom name="R_UL" fromto="0 0 0 0 0.06 -0.413"
              size="0.069" class="R_collision"/>
          <geom name="R_pilot_thigh" fromto="0 .166 -.05 0 .149 -.423" size=".069" class="ballast"/>
          <site name="tor_R_HFE" size="0.01" pos="0 0 0"/>

          <body name="R_LL" pos="0 0.06 -0.413">
            <inertial pos="-0.034 0.04 -0.223" mass="4.159"
                  fullinertia="0.055 0.064 0.019 -0.001 -0.006 0.002"/>
            <joint name="R_KFE" axis="0 1 0" range="-1 112" class="rotational_joint"/>
            <geom type="mesh" mesh="R_shin"/>
            <geom name="R_LL" fromto="0 0 0 0.0 0.037 -0.414"
              size="0.047" class="R_collision"/>
            <geom name="R_pilot_shin" fromto="0 .116 0 0 .124 -.399"  size=".047" class="ballast"/>
            <site name="tor_R_KFE" size="0.01" pos="0 0 0"/>

            <body name="R_foot" pos="0.0 0.037 -0.414">
              <inertial pos="0.033 0.041 -0.08" mass="1.22"
                  fullinertia="0.006 0.01 0.008 -0.001 0.002 0.002"/>
              <joint name="R_ADPF" axis="0 -1 0" range="-25 1" class="ADPF_joint"/>
              <geom type="mesh" mesh="R_foot"/>
              <site name="tor_R_ADPF" size="0.01" pos="0 0 0"/>

              <!-- The R_foot geometry models a footplate which extends past the pressure pads on the soles-->
              <geom name="R_foot" type="box" size="0.159 0.057 0.007"
                  pos="0.069 0.086 -0.118"  class="R_collision"
                  friction="0.33"/>

                  <!-- Pressure sole  -->
              <body name="pres_R_0" pos="-0.045 0.072 -0.138">
                <geom name="pres_R_0" type="sphere" pos="0 0 0"
                      size="0.01" class="L_collision"  friction="0.33"/>
                <site name="pres_R_0"/>
              </body>
              <body name="pres_R_1" pos="-0.045 0.072 -0.138">
                <geom name="pres_R_1" type="sphere" pos="0 0 0"
                      size="0.01" class="L_collision"  friction="0.33"/>
                <site name="pres_R_1"/>
              </body>
              <body name="pres_R_2" pos="0.05 0.061 -0.138">
                <geom name="pres_R_2" type="sphere" pos="0 0 0"
                      size="0.01" class="L_collision"  friction="0.33"/>
                <site name="pres_R_2"/>
              </body>
              <body name="pres_R_3" pos="0.118 0.05 -0.138">
                <geom name="pres_R_3" type="sphere" pos="0 0 0"
                      size="0.01" class="L_collision"  friction="0.33"/>
                <site name="pres_R_3"/>
              </body>
              <body name="pres_R_4" pos="0.13 0.083 -0.138">
                <geom name="pres_R_4" type="sphere" pos="0 0 0"
                      size="0.01" class="L_collision"  friction="0.33"/>
                <site name="pres_R_4"/>
              </body>
              <body name="pres_R_5" pos="0.137 0.115 -0.138">
                <geom name="pres_R_5" type="sphere" pos="0 0 0"
                      size="0.01" class="L_collision"  friction="0.33"/>
                <site name="pres_R_5"/>
              </body>
              <body name="pres_R_6" pos="0.174 0.07 -0.138">
                <geom name="pres_R_6" type="sphere" pos="0 0 0"
                      size="0.01" class="L_collision"  friction="0.33"/>
                <site name="pres_R_6"/>
              </body>
              <body name="pres_R_7" pos="0.184 0.105 -0.138">
                <geom name="pres_R_7" type="sphere" pos="0 0 0"
                      size="0.01" class="L_collision"  friction="0.33"/>
                <site name="pres_R_7"/>
              </body>
            </body>
          </body>
        </body>
      </body>

    </body>
  </worldbody>

  <actuator>
    <!-- User parameter is the maximum no-load motor RPM -->
    <motor name="L_ADPF"    gear="179"  joint="L_ADPF"  />
    <motor name="L_HAA"     gear="280"  joint="L_HAA"  />
    <motor name="L_HFE"     gear="250" joint="L_HFE"   />
    <motor name="L_KFE"     gear="250"  joint="L_KFE"   />
    <motor name="R_ADPF"    gear="179"  joint="R_ADPF"  />
    <motor name="R_HAA"     gear="280"  joint="R_HAA"  />
    <motor name="R_HFE"     gear="250" joint="R_HFE"   />
    <motor name="R_KFE"     gear="250"  joint="R_KFE" />
  </actuator>

  <sensor>
    <!-- User parameter is the number of absolute encoder bits -->
    <!-- encodersoutput position; connected to the actuator -->
    <jointpos name="L_ADPF_pos_output" joint="L_ADPF" user="18" noise="000"/>
    <jointpos name="L_HAA_pos_output" joint="L_HAA" user="18" noise="000"/>
    <jointpos name="L_HFE_pos_output" joint="L_HFE" user="18" noise="000"/>
    <jointpos name="L_KFE_pos_output" joint="L_KFE" user="18" noise="000"/>
    <jointpos name="R_ADPF_output" joint="R_ADPF" user="18" noise="000"/>
    <jointpos name="R_HAA_output" joint="R_HAA" user="18" noise="000"/>
    <jointpos name="R_HFE_output" joint="R_HFE" user="18" noise="000"/>
    <jointpos name="R_KFE_output" joint="R_KFE" user="18" noise="000"/>
    <!-- encodersoutput velocity; connected to the actuator -->
    <jointvel name="L_ADPF_vel_output" joint="L_ADPF" user="18" noise="000"/>
    <jointvel name="L_HAA_vel_output" joint="L_HAA" user="18" noise="000"/>
    <jointvel name="L_HFE_vel_output" joint="L_HFE" user="18" noise="000"/>
    <jointvel name="L_KFE_vel_output" joint="L_KFE" user="18" noise="000"/>
    <jointvel name="R_ADPF_vel_output" joint="R_ADPF" user="18" noise="000"/> 
    <jointvel name="R_HAA_vel_output" joint="R_HAA" user="18" noise="000"/>
    <jointvel name="R_HFE_vel_output" joint="R_HFE" user="18" noise="000"/>
    <jointvel name="R_KFE_vel_output" joint="R_KFE" user="18" noise="000"/>
    <!-- torque sensors; connected to the actuator-->

<!--    TODO: This could also be of the type actuatorvel -->
    <torque name="L_ADPF_tor_output" site="tor_L_ADPF" user="13" noise="000"/>
    <torque name="L_HAA_tor_output" site="tor_L_HAA" user="13" noise="000"/>
    <torque name="L_HFE_tor_output" site="tor_L_HFE" user="13" noise="000"/>
    <torque name="L_KFE_tor_output" site="tor_L_KFE" user="13" noise="000"/>
    <torque name="R_ADPF_tor_output" site="tor_R_ADPF" user="13" noise="000"/>
    <torque name="R_HAA_tor_output" site="tor_R_HAA" user="13" noise="000"/>
    <torque name="R_HFE_tor_output" site="tor_R_HFE" user="13" noise="000"/>
    <torque name="R_KFE_tor_output" site="tor_R_KFE" user="13" noise="000"/>

    <!-- pressure soles not finished yet -->
    <force name="L_pressuresole_1_output" site="pres_L_0" noise="000" cutoff="000"/>
    <force name="L_pressuresole_2_output" site="pres_L_1" noise="000" cutoff="000"/>
    <force name="L_pressuresole_3_output" site="pres_L_2" noise="000" cutoff="000"/>
    <force name="L_pressuresole_4_output" site="pres_L_3" noise="000" cutoff="000"/>
    <force name="L_pressuresole_5_output" site="pres_L_4" noise="000" cutoff="000"/>
    <force name="L_pressuresole_6_output" site="pres_L_5" noise="000" cutoff="000"/>
    <force name="L_pressuresole_7_output" site="pres_L_6" noise="000" cutoff="000"/>
    <force name="L_pressuresole_8_output" site="pres_L_7" noise="000" cutoff="000"/>

    <force name="R_pressuresole_1_output" site="pres_R_0" noise="000" cutoff="000"/>
    <force name="R_pressuresole_2_output" site="pres_R_1" noise="000" cutoff="000"/>
    <force name="R_pressuresole_3_output" site="pres_R_2" noise="000" cutoff="000"/>
    <force name="R_pressuresole_4_output" site="pres_R_3" noise="000" cutoff="000"/>
    <force name="R_pressuresole_5_output" site="pres_R_4" noise="000" cutoff="000"/>
    <force name="R_pressuresole_6_output" site="pres_R_5" noise="000" cutoff="000"/>
    <force name="R_pressuresole_7_output" site="pres_R_6" noise="000" cutoff="000"/>
    <force name="R_pressuresole_8_output" site="pres_R_7" noise="000" cutoff="000"/>

    <!-- Noise & cutoff must be determined -->
    <framequat name='backpack_orientation' objtype='site' objname='imu_backpack'/>
    <gyro name='vel_imu_backpack' site='imu_backpack' noise='5e-4' cutoff='34.9'/>
    <accelerometer name='acc_imu_backpack' site='imu_backpack' noise='1e-2' cutoff='157'/>
    <magnetometer name='magnet_imu_backpack' site='imu_backpack'/>

    <framequat name='torso_orientation' objtype='site' objname='imu_torso'/>
    <gyro name='vel_imu_torso' site='imu_torso' noise='5e-4' cutoff='34.9'/>
    <accelerometer name='acc_imu_torso' site='imu_torso' noise='1e-2' cutoff='157'/>
    <magnetometer name='magnet_imu_torso' site='imu_torso'/>

  </sensor>
</mujoco>